//+------------------------------------------------------------------+
//|                                     diplonema RSI GodLuck v1.mq4 |
//|                                                            xujie |
//+------------------------------------------------------------------+
#property copyright   "xujie"
#property link        ""
#define indicator_name  "GLI dRSI"
#define arrsize 22   

//----
#property indicator_separate_window
//#property indicator_minimum 0
//#property indicator_maximum 100
//#property indicator_levelcolor DarkSlateGray
//#property indicator_level1  50
#property indicator_buffers 6
#property indicator_color1  Aqua
#property indicator_color2  Gold
#property indicator_color3  Green
#property indicator_color4  Maroon
#property indicator_color5  Lime
#property indicator_color6  Red
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  1
#property indicator_width4  1
#property indicator_width5  1
#property indicator_width6  1

//---- input parameters
extern int    RSI_period   = 9;
extern int    AppliedPrice = 0;
extern int    timeframe    = 0;

extern int    Rightshift   = 0;//28;
extern int    MaxBars      = 300;
extern bool   VisualAlert  = false;

//---- buffers
double baseRSI[];
double targetRSI[];
double powerUP[];
double powerDN[];
double long[];
double short[];

//----
int Wilders_Period;
int StartBar;

string aPair[arrsize] = {"EURUSD", "GBPUSD", "USDJPY", "USDCHF", "AUDUSD", "USDCAD", "EURCHF", "EURGBP", "EURJPY", "EURCAD", "EURAUD", "GBPJPY", "GBPCHF", "CHFJPY", "GBPCAD", "GBPAUD", "AUDCAD", "CADCHF", "AUDJPY", "GBPNZD", "NZDUSD", "EURNZD"};
//string aPair[arrsize] = {"EURUSD","GBPUSD","AUDUSD","USDJPY","USDCHF","USDCAD",
//                              "EURJPY","EURGBP","EURCHF","EURAUD","GBPJPY","GBPCHF"};

double aRatio[2];

string short_name;

static datetime option_tag;
static datetime alertTag = D'1980.01.01'; 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(6);

   //----
   SetIndexStyle(0, DRAW_LINE);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexStyle(3, DRAW_LINE);
   SetIndexStyle(4, DRAW_ARROW);
   SetIndexArrow(4, 167);
   SetIndexStyle(5, DRAW_ARROW);
   SetIndexArrow(5, 167);
   
   SetIndexBuffer(0, baseRSI);
   SetIndexBuffer(1, targetRSI);
   SetIndexBuffer(2, long);
   SetIndexBuffer(3, short);
   SetIndexBuffer(4, powerUP);
   SetIndexBuffer(5, powerDN);

   SetIndexShift(0, Rightshift);
   SetIndexShift(1, Rightshift);
   SetIndexShift(2, Rightshift);
   SetIndexShift(3, Rightshift);
   SetIndexShift(4, Rightshift);
   SetIndexShift(5, Rightshift);

   SetIndexLabel(0, NULL);
   SetIndexLabel(1, NULL);
   SetIndexLabel(2, NULL);
   SetIndexLabel(3, NULL);
   SetIndexLabel(4, NULL);
   SetIndexLabel(5, NULL);

   //---
   if (timeframe<=0) timeframe = Period();
   short_name = indicator_name + " [" + Periodo(timeframe) + "]";
   IndicatorShortName(short_name);
   
   //IndicatorDigits(Digits);
   
   //----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   //----
   ObjectsDeleteAll(WindowFind(short_name));  
   
   //----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    count_base, count_target;
   string symbol;
   double rsi_temp;
   
   string pair_base   = StringSubstr(Symbol(), 0, 3);
   string pair_target = StringSubstr(Symbol(), 3, 3);
   string pair_suffix = StringSubstr(Symbol(), 6, StringLen(Symbol())-6);  

   RefreshRates();
   
   int limit;
   int counted_bars = IndicatorCounted();

   // -- last counted bar will be recounted
   if (counted_bars>0) counted_bars--;
   limit = Bars - counted_bars;
   limit = MathMin(limit, MaxBars);

   set_level(MaxBars-1);
   
   //----
   for (int i=0; i<limit; i++)
     {
      //
      aRatio[0] = 0;
      aRatio[1] = 0;
      count_base   = 0;
      count_target = 0;

      for (int j=0; j<arrsize; j++)
        {
         symbol = aPair[j] + pair_suffix;
         if (MarketInfo(symbol, MODE_TRADEALLOWED)==1)
           {
            if (StringSubstr(aPair[j],0,3)==pair_base)
              {
               rsi_temp = iRSI(symbol, timeframe, RSI_period, AppliedPrice, i);
               if (rsi_temp>0) { aRatio[0] = aRatio[0] + rsi_temp; count_base++; }
              }
            if (StringSubstr(aPair[j],3,3)==pair_base)
              {
               rsi_temp = iRSI(symbol, timeframe, RSI_period, AppliedPrice, i);
               if (rsi_temp>0) { aRatio[0] = aRatio[0] + (100-rsi_temp); count_base++; }
              }
            if (StringSubstr(aPair[j],0,3)==pair_target)
              {
               rsi_temp = iRSI(symbol, timeframe, RSI_period, AppliedPrice, i);
               if (rsi_temp>0) { aRatio[1] = aRatio[1] + rsi_temp; count_target++; }
              }
            if (StringSubstr(aPair[j],3,3)==pair_target)
              {
               rsi_temp = iRSI(symbol, timeframe, RSI_period, AppliedPrice, i);
               if (rsi_temp>0) { aRatio[1] = aRatio[1] + (100-rsi_temp); count_target++; }
              }
           }   
        } 
      if (count_base>0)   { baseRSI[i] = (aRatio[0]/count_base); }
      if (count_target>0) { targetRSI[i] = (aRatio[1]/count_target); }
     }

   for (i=limit-1; i>=0; i--)
     {
      if (baseRSI[i]>targetRSI[i]) long[i] = 50; else long[i] = EMPTY_VALUE;
      if (baseRSI[i]<targetRSI[i]) short[i] = 50; else short[i] = EMPTY_VALUE;
      if (baseRSI[i]>targetRSI[i] && baseRSI[i]>=50 && baseRSI[i]>baseRSI[i+1] && targetRSI[i]<targetRSI[i+1]) powerUP[i] = 50; else powerUP[i] = EMPTY_VALUE;
      if (baseRSI[i]<targetRSI[i] && baseRSI[i]<50 && baseRSI[i]<baseRSI[i+1] && targetRSI[i]>targetRSI[i+1]) powerDN[i] = 50; else powerDN[i] = EMPTY_VALUE;
      if (VisualAlert == true && i == 0 && alertTag !=Time[0])
        {
         if (baseRSI[i] > targetRSI[i] && baseRSI[i+1] < targetRSI[i+1])
           {
            Alert("RSIʾ[", pair_base, "]ʼǿ[", pair_target, "]  - [", Symbol(), "] - [", Periodo(Period()) + "]");
            alertTag = Time[0];
           }
         if (baseRSI[i] < targetRSI[i] && baseRSI[i+1] > targetRSI[i+1])
           {
            Alert("RSIʾ[", pair_base, "]ʼ[", pair_target, "]  - [", Symbol(), "] - [", Periodo(Period()) + "]");
            alertTag = Time[0];
           }
       }   
     }     
   
   set_info(pair_base, pair_target, baseRSI[0], baseRSI[1], targetRSI[0], targetRSI[1]);
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom functions and procedures                                  |
//+------------------------------------------------------------------+
void set_level(int time1)
  {
   string str_prefix = "[" + short_name + "][level]";

   string level_70  = str_prefix + "[70]", level_30  = str_prefix + "[30]";

   draw_hline(level_70, 70, STYLE_DOT, DarkSlateGray, time1);
   draw_hline(level_30, 30, STYLE_DOT, DarkSlateGray, time1);
  }

int draw_hline(string name, int y, int line_style, color line_color, int bars)
  {
   if (ObjectFind(name)==-1)
     {
      ObjectCreate(name, OBJ_TREND, WindowFind(short_name), 0, 0);
      ObjectSet(name, OBJPROP_STYLE, line_style);
      ObjectSet(name, OBJPROP_COLOR, line_color);
      ObjectSet(name, OBJPROP_BACK, true);
      ObjectSet(name, OBJPROP_RAY, false);
      ObjectSet(name, OBJPROP_PRICE1, y);
      ObjectSet(name, OBJPROP_PRICE2, y);
     }
   if (ObjectGet(name, OBJPROP_TIME1) != Time[bars])
     ObjectSet(name, OBJPROP_TIME1, Time[bars]);
   if (ObjectGet(name, OBJPROP_TIME2) != Time[0])
     ObjectSet(name, OBJPROP_TIME2, Time[0]);
     
   return (0);
  }


void set_info(string base_pair, string target_pair, double base_value, double pre_base_value, double target_value, double pre_target_value)
  {
   string str_prefix = "[" + short_name + "][info]";
   
   string base_pair_t   = str_prefix + "base_pair_t", base_pair_v   = str_prefix + "base_pair_v",  base_s   = str_prefix + "base_pair_s",
          target_pair_t = str_prefix + "target_pair_t", target_pair_v = str_prefix + "target_pair_v", target_s = str_prefix + "target_s";
   string discrete_t = str_prefix + "discrete_t", discrete_v = str_prefix + "discrete_v", discrete_s = str_prefix + "discrete_s";
   string action_t = str_prefix + "action_t", action_v = str_prefix + "action_v",
          option_t = str_prefix + "option_t", option_v = str_prefix + "option_v";
   string alarm_t = str_prefix + "alarm_t", alarm_v = str_prefix + "alarm_v";
   string split1 = str_prefix + "split1", split2 = str_prefix + "split2", split3 = str_prefix + "split3";  
   
   int corner_of_chart = 1;

   string base_title = base_pair +":",
          target_title = target_pair +":";
   string discrete_title = "DISCRETION:",
          action_title   = "ACTION:",
          option_title   = "OPTION:";
   string alarm_title = "ALARM :";
   
   string split = "____________________________";

   color data_title_clr = LightSlateGray,
         operate_title_clr = DimGray, 
         alarm_title_clr = LightSlateGray; 
   
   int xdistance_base = 122, xdistance_target = 45;
   int xdistance_discrete = 85;
   int xdistance_action = 107, xdistance_option = 107;
   int xdistance_split1 = 6, xdistance_split2 = 6, xdistance_split3 = 6;
   int xdistance_alarm = 107;

   int ydistance_base = 3, ydistance_target = 3;
   int ydistance_discrete = 21;
   int ydistance_action = 38, ydistance_option = 50;
   int ydistance_split1 = 7, ydistance_split2 = 24, ydistance_split3 = 53;
   int ydistance_alarm = 66;

   string action_text = " ",
          option_text = " ";

   string base_sign,
          target_sign,
          discrete_sign;

   int base_sign_adjust,
       target_sign_adjust,
       discrete_sign_adjust;
   
   string sign_up = CharToStr(233),
          sign_dn = CharToStr(234),
          sign_st = CharToStr(104); 
   int sign_up_adjust = 0,
       sign_dn_adjust = 2,
       sign_st_adjust = 2;
   
   color clr_bull = Lime,
         clr_bear = Red,
         clr_none = Wheat;        
   color clr_long_strong = Lime,
         clr_long_weak = Green,
         clr_short_strong = Red,
         clr_short_weak = Brown;
   
   color base_clr,
         target_clr,
         discrete_clr;
   
   color action_clr;
   
   if (base_value>pre_base_value) { base_sign = sign_up; base_sign_adjust = sign_up_adjust; }
   else 
     if (base_value<pre_base_value) { base_sign = sign_dn; base_sign_adjust = sign_dn_adjust; }
     else { base_sign = sign_st; base_sign_adjust = sign_st_adjust; } 
   if (target_value>pre_target_value) { target_sign = sign_up; target_sign_adjust = sign_up_adjust; }
   else 
     if (target_value<pre_target_value) { target_sign = sign_dn; target_sign_adjust = sign_dn_adjust; }
     else { target_sign = sign_st; target_sign_adjust = sign_st_adjust; } 
   if ((base_value-target_value)>(pre_base_value-pre_target_value)) { discrete_sign = sign_up; discrete_sign_adjust = sign_up_adjust; }
   else 
     if ((base_value-target_value)<(pre_base_value-pre_target_value)) { discrete_sign = sign_dn; discrete_sign_adjust = sign_dn_adjust; }
     else { discrete_sign = sign_st; discrete_sign_adjust = sign_st_adjust; } 
         
   if (base_value>50) base_clr = clr_bull;
   else 
     if (base_value<50) base_clr = clr_bear;
     else base_clr = clr_none;
   
   if (target_value>50) target_clr = clr_bull;
   else 
     if (target_value<50) target_clr = clr_bear;
     else target_clr = clr_none;
   
   if (base_value>target_value)
     { 
      discrete_clr = clr_bull; 
      action_text = "LONG";
      if (base_value>=50) action_clr = clr_long_strong;
      else action_clr = clr_long_weak;
     } 
   else
     if (base_value<target_value)
       {
        discrete_clr = clr_bear; 
        action_text = "SHORT";
        if (target_value>=50) action_clr = clr_short_strong;
        else action_clr = clr_short_weak;
       } 
     else
       {
        discrete_clr = clr_none; 
        action_text = ""; 
        action_clr = clr_none;
       } 
   
   if ((base_value>target_value) && (pre_base_value<=pre_target_value)) { option_text = "EXIT SHORT"; option_tag = Time[0]; }
   else
     if ((base_value<target_value) && (pre_base_value>=pre_target_value)) { option_text = "EXIT LONG"; option_tag = Time[0]; }
   
   if (option_tag<=Time[2]) { option_text = " "; option_tag = Time[10]; }
   
   //----
   color alarm_clr = Red;
       
   draw_label(base_pair_t, base_title, corner_of_chart, xdistance_base, ydistance_base, 7, "Arial", indicator_color1);
   draw_label(target_pair_t, target_title, corner_of_chart, xdistance_target, ydistance_target, 7, "Arial", indicator_color2);
   draw_label(base_pair_v, DoubleToStr(base_value, 2), corner_of_chart, xdistance_base-28, ydistance_base, 7, "Arial", base_clr);
   draw_label(base_s, base_sign, corner_of_chart, xdistance_base - 39, ydistance_base + base_sign_adjust, 7, "Wingdings", base_clr);
   draw_label(target_pair_v, DoubleToStr(target_value, 2), corner_of_chart, xdistance_target - 28, ydistance_target, 7, "Arial", target_clr);
   draw_label(target_s, target_sign, corner_of_chart, xdistance_target - 39, ydistance_target + target_sign_adjust, 7, "Wingdings", target_clr);

   draw_label(discrete_t, discrete_title, corner_of_chart, xdistance_discrete, ydistance_discrete, 7, "Arial", data_title_clr);
   draw_label(discrete_v, DoubleToStr(MathAbs(base_value-target_value), 2), corner_of_chart, xdistance_discrete - 35, ydistance_discrete, 7, "Arial", discrete_clr);
   draw_label(discrete_s, discrete_sign, corner_of_chart, xdistance_discrete - 47, ydistance_discrete + discrete_sign_adjust, 7, "Wingdings", discrete_clr);

   draw_label(action_t, action_title, corner_of_chart, xdistance_action, ydistance_action, 7, "Arial", operate_title_clr);
   draw_label(action_v, action_text, corner_of_chart, xdistance_action - 62, ydistance_action, 7, "Arial", discrete_clr);

   draw_label(option_t, option_title, corner_of_chart, xdistance_option, ydistance_option, 7, "Arial", operate_title_clr);
   draw_label(option_v, option_text, corner_of_chart, xdistance_option - 70, ydistance_option + 1, 6, "Arial", alarm_clr);

   draw_label(alarm_t, alarm_title, corner_of_chart, xdistance_alarm, ydistance_alarm, 7, "Arial", alarm_title_clr);

   draw_label(split1, split, corner_of_chart, xdistance_split1, ydistance_split1, 7, "Arial", C'0x32,0x32,0x32');
   draw_label(split2, split, corner_of_chart, xdistance_split2, ydistance_split2, 7, "Arial", C'0x32,0x32,0x32');
   draw_label(split3, split, corner_of_chart, xdistance_split3, ydistance_split3, 7, "Arial", C'0x32,0x32,0x32');
   
  }

int draw_label(string name, string text, int corner_of_chart, int x, int y, int font_size, string font_name, color font_color)
  {
   ObjectCreate(name, OBJ_LABEL, WindowFind(short_name), 0, 0);
   ObjectSet(name, OBJPROP_CORNER, corner_of_chart);
   ObjectSet(name, OBJPROP_XDISTANCE, x);
   ObjectSet(name, OBJPROP_YDISTANCE, y);
   ObjectSet(name, OBJPROP_BACK, false);
   ObjectSetText(name, text, font_size, font_name, font_color);

   return (0);
  }

string Periodo(int TF)
  {
   if (TF== 1)    { return("M1"); }
   if (TF== 5)    { return("M5"); }
   if (TF== 15)   { return("M15"); }
   if (TF== 30)   { return("M30"); } 
   if (TF== 60)   { return("H1"); } 
   if (TF==240)  { return("H4"); } 
   if (TF==1440) { return("D1"); }  
  }

//+------------------------------------------------------------------+